﻿/*
 *Copyright(C) 2023 by Chief All rights reserved.
 *Unity版本：2020.3.41f1c1 
 *作者:Chief  
 *创建日期: 2022-12-06 
 *模块说明：
 *版本: 1.0
*/

using Sirenix.OdinInspector;
using System;
using UnityEditor;
using UnityEngine;

namespace Lycianthes
{
    /// <summary>
    /// 本地配置
    /// </summary>
    [Serializable]
    public class LycianthesConfig
    {

        public string GetJsonString() { return JsonUtility.ToJson(this); }

        public static LycianthesConfig FromJson(string json) { return JsonUtility.FromJson<LycianthesConfig>(json); }

        /// <summary>
        /// 本地配置；
        /// </summary>
        public const string KEY_LYCIANTHES_CONFIG = "KEY_LYCIANTHES_CONFIG";
        private static LycianthesConfig instance;

        public static LycianthesConfig GetInstance()
        {
            if (instance != null) return instance;

            if (!PlayerPrefs.HasKey(KEY_LYCIANTHES_CONFIG))
            {
                instance = new LycianthesConfig();
                instance.CompanyName = PlayerSettings.companyName;
                instance.AuthorName = "New User";
                return instance;
            }

            var jsonStr = PlayerPrefs.GetString(KEY_LYCIANTHES_CONFIG);
            instance = FromJson(jsonStr);
            return instance;
        }


        [LabelText("作者"), LabelWidth(60)]
        public string AuthorName;

        [LabelText("公司名"), LabelWidth(60)]
        public string CompanyName;

        [LabelText("模块说明"), LabelWidth(60)]
        public bool UseModuleInfo = true;

    }
}